REM Released into the public domain April 1, 1995

DECLARE SUB DebugInfoFile (timeonlinethiscall%, timeonlinebefore%, timeonlineafter%, todaynum%, who%)
DECLARE SUB OpeningScreen ()
' Tracker! by Cory Wright, originally of 08/09/1989
' Tracker updated to v2.01b (skipping release 2.00) starting 10/22
'
'$INCLUDE: 'QBSERIAL.DEC'
'$INCLUDE: 'TRACKER.BI'
' The following file is a TheDraw uncruncher header file
'$INCLUDE: 'QB4UTIL.BI'
' More functions for use with TheDraw

'$DYNAMIC
DIM SHARED Param$(0 TO 40)
DIM SHARED hue$(1 TO 15)      ' array of color
DIM SHARED desc$(1 TO 300)    ' descriptions of msgbases, from TSCAN.DIR

VIEW PRINT 1 TO 25
ON ERROR GOTO Lab20000

ver$ = "v3.00"
versiondate$ = SPACE$(1) + "of 05/22/1994"
verdate$ = versiondate$ + "; Copyright 1989-1994 Cory Wright."
registeredstr$ = "REGISTERED"
unregisteredstr$ = "UN" + registeredstr$
false = 0
true = NOT false
debug = true
null = false
override = false
CRLF$ = CHR$(13) + CHR$(10)

'Show opening screen
OpeningScreen
SLEEP (1)

' get weekday
CALL weekday(day%)
dlen% = VAL(MID$("3346535", day%, 1))
dloc% = ASC(MID$("ADGKQVY", day%)) - 64
day$ = MID$("SunMonTuesWednesThursFriSaturSun", dloc%, dlen%) + "day,"

' initialize global variables
GTPath$ = ENVIRON$("GTPATH")
GTPath$ = UCASE$(GTPath$)
IF GTPath$ = "" THEN
  COLOR 12
  BEEP
  BEEP
  CTR "TRACKER:  Your GTPATH must be SET to your GT Directory."
  END
END IF
IF RIGHT$(GTPath$, 1) <> "\" THEN GTPath$ = GTPath$ + "\"

valid% = 0
tpath$ = GTPath$ + "TRC"
CALL subexist(tpath$ + CHR$(0), valid%) ' check for path existence
IF NOT valid% THEN MKDIR tpath$         ' if not, make it
tpath$ = tpath$ + "\"  ' add trailing backslash for future

mo$ = SPACE$(9)
mnum% = VAL(LEFT$(DATE$, 2))
CALL month(mo$, ml%, mnum%)
mth$ = LEFT$(mo$, ml%)

daynum$ = MID$(DATE$, 4, 2)
IF LEFT$(daynum$, 1) = "0" THEN daynum$ = RIGHT$(daynum$, 1)
daynum$ = daynum$ + ","

FixTime TIME$, timeconv$
current$ = day$ + SPACE$(1) + mth$ + SPACE$(1) + daynum$ + SPACE$(1) + RIGHT$(DATE$, 4)

trakinf$ = tpath$ + "tracker.inf"
trakcnf$ = tpath$ + "tracker.cnf"
trakt$ = tpath$ + "traktime.dat"
trakdb$ = tpath$ + "tscan.db"
trakdir$ = tpath$ + "tscan.dir"
traknames$ = tpath$ + "tscan.nam"
traknamesnew$ = tpath$ + "names.new"

userctl$ = GTPath$ + "user.ctl"
gtuser$ = GTPath$ + "gtuser.bbs"
acceptfile$ = GTPath$ + "accept.trc"

'init traktime.dat and tracker.cnf if doesn't exist
CALL exist(trakt$ + CHR$(0), th%)
IF NOT th% THEN           'Init TRAKTIME.DAT
  OPEN trakt$ FOR RANDOM AS 2 LEN = LEN(traktime)
  FOR J = 1 TO 7
	traktime.ucall = 0
	traktime.scall = 0
	traktime.utime = 0
	traktime.stime = 0
	traktime.day = 0
	PUT 2, J, traktime
  NEXT J
  CLOSE 2
END IF
CALL exist(trakcnf$ + CHR$(0), th%)
IF NOT th% THEN             'init TRACKER.CNF
  OPEN trakcnf$ FOR RANDOM AS 2 LEN = LEN(cnf)
  cnf.header = ver$
  cnf.bbs = "The Rising Connection"
  cnf.serial = 0
  cnf.crc = "0000-0000"
  cnf.ratiof = 0
  cnf.ratiok = 0
  cnf.border = 3
  cnf.text = 7
  cnf.bright = 11
  cnf.info = 15
  cnf.udirpath = ""
  cnf.todaybullb = GTPath$ + "whotoday.bbs"
  cnf.todaybullc = GTPath$ + "whotoday.cbs"
  cnf.yestbullb = GTPath$ + "whoyest.bbs"
  cnf.yestbullc = GTPath$ + "whoyest.cbs"
  cnf.altmdir = GTPath$ + "gtmdir.bbs"
  cnf.mailscan = -1
  cnf.accept300 = -1
  cnf.accept1200 = -1
  cnf.accept2400 = -1
  cnf.accept4800 = -1
  cnf.exemptlevels = ""
  cnf.sysannounce = ""
  cnf.gtversion = 18
  cnf.misc = ""
  cnf.fshare = 0
  cnf.ratiocheck = 0
  cnf.other = 7
  PUT 2, 1, cnf
  CLOSE 2
END IF

'get configuration information
OPEN trakcnf$ FOR RANDOM AS 2 LEN = LEN(cnf)
GET 2, 1, cnf
header$ = LTRIM$(RTRIM$(cnf.header))
bbs$ = LTRIM$(RTRIM$(cnf.bbs))
serial = cnf.serial
usercrc$ = LTRIM$(RTRIM$(cnf.crc))
ratiof = cnf.ratiof
ratiok = cnf.ratiok
udir$ = LTRIM$(RTRIM$(cnf.udirpath))
tbullb$ = RTRIM$(cnf.todaybullb)
tbullc$ = RTRIM$(cnf.todaybullc)
ybullb$ = RTRIM$(cnf.yestbullb)
ybullc$ = RTRIM$(cnf.yestbullc)
gtmdir$ = RTRIM$(cnf.altmdir)
mailscan = cnf.mailscan
three = cnf.accept300
twelve = cnf.accept1200
twentyfour = cnf.accept2400
fortyeight = cnf.accept4800
exemptlvl$ = cnf.exemptlevels
gtver = cnf.gtversion
fileshare = cnf.fshare
ratiochk = cnf.ratiocheck

border = 9
text = 7
bright = 15
info = 14

CLOSE 2


'parse GT.CNF to find sysop base
ff = FREEFILE
found1 = 0
found2 = 0
IF fileshare THEN
  OPEN GTPath$ + "GT.CNF" FOR INPUT ACCESS READ SHARED AS ff
 ELSE
  OPEN GTPath$ + "GT.CNF" FOR INPUT AS ff
END IF

DO WHILE NOT EOF(ff)
	LINE INPUT #ff, gtln$
	IF LEFT$(gtln$, 3) = "CM=" THEN
	  Port% = VAL(RIGHT$(gtln$, LEN(gtln$) - 3))
	  found1 = -1
	 ELSEIF LEFT$(gtln$, 3) = "TB=" THEN
'background statusline color
	  bground = VAL(RIGHT$(gtln$, LEN(gtln$) - 3))
	  found2 = -1
	END IF
	IF found1 = -1 AND found2 = -1 THEN EXIT DO
LOOP
CLOSE ff



	DrawScreen


' call other procedures
	IF INSTR(COMMAND$, "CONFIG") THEN
	  BEEP
	  LOCATE 1, 1
	  PRINT "- CONFIG is no longer an option, use TCONFIG.EXE to configure TRACKER."
	  END
	 ELSEIF INSTR(COMMAND$, "INIT") THEN
	  Init
	  END
	 ELSEIF INSTR(COMMAND$, "END") THEN
	  Logoff
	 ELSEIF INSTR(COMMAND$, "SCAN") THEN
	  BEEP
	  LOCATE 1, 1
		  PRINT "- SCAN has been moved to TSCAN.EXE in this verrsion of Tracker."
		  PRINT "  Run TSCAN in your nightly maintenance batch file."
		  ' TSCAN.EXE is the program that scans for mail.
		  END
	END IF

	IF INSTR(COMMAND$, "NULL") THEN null = true
	IF INSTR(COMMAND$, "OVERRIDE") THEN override = true

' main code
	CALL exist(trakinf$ + CHR$(0), there%)
	IF NOT there% THEN
	  LOCATE 1, 1
	  PRINT "- "; trakinf$; " not found.  Creating..."
	  CALL delay(1)
	  Init
	  CALL delay(1)
	  RUN
	  END
	END IF

	COLOR 15, bground
	LOCATE 24, 2
	PRINT "Reading TRACKER.INF...";

	IF fileshare THEN
	  OPEN trakinf$ FOR INPUT ACCESS READ SHARED AS 1
	 ELSE
	  OPEN trakinf$ FOR INPUT AS 1
	END IF
	LINE INPUT #1, total$
	LINE INPUT #1, laston$
	LINE INPUT #1, city$
	LINE INPUT #1, today$
	LINE INPUT #1, ctoday$
	CLOSE

	ParseUser

	IF null = true THEN
	  baud$ = "LOCAL"
	  ansi$ = "ANSI"
	END IF

	IF baud$ <> "LOCAL" THEN
'   ON UEVENT GOSUB 30000'set up tracking after parsing
'   UEVENT ON
	END IF

	IF ansi$ = "ANSI" THEN
	  hue$(1) = CHR$(27) + "[0;34m"
	  hue$(2) = CHR$(27) + "[0;32m"
	  hue$(3) = CHR$(27) + "[0;36m"
	  hue$(4) = CHR$(27) + "[0;31m"
	  hue$(5) = CHR$(27) + "[0;35m"
	  hue$(6) = CHR$(27) + "[0;33m"
	  hue$(7) = CHR$(27) + "[0m"
	  hue$(8) = CHR$(27) + "[1;30m"
	  hue$(9) = CHR$(27) + "[1;34m"
	  hue$(10) = CHR$(27) + "[1;32m"
	  hue$(11) = CHR$(27) + "[1;36m"
	  hue$(12) = CHR$(27) + "[1;31m"
	  hue$(13) = CHR$(27) + "[1;35m"
	  hue$(14) = CHR$(27) + "[1;33m"
	  hue$(15) = CHR$(27) + "[1;37m"
	  clreol$ = CHR$(27) + "[K"
	 ELSE
	  FOR z = 1 TO 15
		hue$(z) = ""
	  NEXT z
	  clreol$ = ""
	END IF
   
	IF baud$ = "LOCAL" THEN Port% = 0

	' OPENCOMM Port%, IRQ/Stat%, Wordlen%, Parity%, BaudRate&, HS%, FOSSIL%
	OpenComm Port%, 0, 8, 0, 0, 3, 0

'fix local logon string
	showbaud$ = baud$

' check registration
	GOSUB Registration

	COLOR info, 0
	LOCATE 1, 1

	Transmit CRLF$ + CRLF$
	Send hue$(7) + "*" + SPACE$(1) + hue$(bright) + "Tracker " + ver$ + hue$(text) + verdate$
	IF register = true THEN
	  q$ = hue$(7) + SPACE$(2) + "[" + hue$(bright) + registeredstr$ + hue$(7) + "]:  "
	  z$ = hue$(bright) + bbs$ + SPACE$(2) + "[#" + LTRIM$(STR$(serial)) + "]"
	  Send q$ + z$
	 ELSE
	  Send hue$(7) + SPACE$(2) + "[" + hue$(12) + unregisteredstr$ + hue$(7) + "]:  " + hue$(12) + "Please register after a 30-day trial period."
	END IF
	GOSUB CHECKFOREVENT
	Send ""
	CALL delay(1)

	IF NOT three THEN DropAtBaud "300"
	IF NOT twelve THEN DropAtBaud "1200"
	IF NOT twentyfour THEN DropAtBaud "2400"
	IF NOT fortyeight THEN DropAtBaud "4800"

	COLOR 15, bground
	LOCATE 24, 2
	PRINT "Searching for user '" + whole$ + "' ...";

	IF fileshare THEN
	  OPEN userctl$ FOR RANDOM ACCESS READ SHARED AS 11 LEN = LEN(user)
	 ELSE
	  OPEN userctl$ FOR RANDOM AS 11 LEN = LEN(user)
	END IF
	recs = LOF(11) / LEN(user)
	FOR A = 2 TO recs
	  GET 11, A, user
	  wholelen = LEN(whole$)
	  IF LEFT$(user.whole, wholelen) = whole$ THEN GOTO Lab1685
	NEXT A    ' A is user number
	BEEP
	LOCATE 24, 2
	COLOR 12
	CTR "I could not find '" + laston$ + "'in the user file!"
	END

Lab1685:
	orgwhole$ = whole$
	dlk = user.dnloadk
	ulk = user.uploadk
	dlf = user.dnloadfiles
	ulf = user.uploadfiles
	ncalls = user.numcalls
	currentcity$ = LEFT$(user.location, INSTR(user.location, CHR$(0)) - 1)
	phone$ = LEFT$(user.phone, INSTR(user.phone, CHR$(0)) - 1)
	reallevel$ = user.level
	IF override = true THEN user.level = "1"
	COLOR 15, bground
	LOCATE 24, 2
	PRINT whole$; SPACE$(23 - LEN(whole$)); TAB(25); SPACE$(1); currentcity$;
	PRINT TAB(50); SPACE$(1); "Lvl "; reallevel$; TAB(57); SPACE$(1); "User#"; LTRIM$(STR$(A - 1));
	LOCATE 25, 2
	IF ansi$ = "ANSI" THEN PRINT "(Ansi)  ";

  IF baud$ <> "LOCAL" THEN
	PRINT "(COM"; LTRIM$(STR$(Port%)); ": "; baud$; ")  ";
   ELSE
	PRINT "(Local)  ";
  END IF

  IF null = true THEN
	user.level = "0"
	GOTO Lab1140
  END IF

Lab1140:
  IF user.level <> "0" THEN total$ = LTRIM$(STR$(VAL(total$) + 1))
  IF today$ = DATE$ THEN
	IF user.level <> "0" THEN
	  ctoday$ = LTRIM$(STR$(VAL(ctoday$) + 1))

	  IF null = true THEN GOTO Lab1200
'add USER call to TRAKTIME
	  OPEN trakt$ FOR RANDOM AS 7 LEN = LEN(traktime)
	  GET 7, day%, traktime
	  IF (user.level <> "0") THEN   'user is on
		traktime.ucall = traktime.ucall + 1
	   ELSE                                               'sysop is on
		traktime.scall = traktime.scall + 1
	  END IF
	  traktime.day = VAL(MID$(DATE$, 4, 2))
	  PUT 7, day%, traktime
Lab1200:
	  CLOSE 7
	 ELSE
	  COLOR 15, bground
	  LOCATE 24, 72
	  PRINT SPACE$(1) + "(SYSOP)"
	  ctoday$ = LTRIM$(STR$(VAL(ctoday$)))

	  IF null = true THEN GOTO Lab1230
'add SYSOP call to TRAKTIME
	  OPEN trakt$ FOR RANDOM AS 7 LEN = LEN(traktime)
	  GET 7, day%, traktime
	  traktime.scall = traktime.scall + 1
	  traktime.day = VAL(MID$(DATE$, 4, 2))
	  PUT 7, day%, traktime
	  CLOSE 7

Lab1230:
	END IF
   ELSE   'set up a new day
	COLOR 31, bground
	LOCATE 24, 66
	PRINT "(WAIT)";
	IF user.level = "0" THEN
	  ctoday$ = "0"
	 ELSE
	  ctoday$ = "1"
	END IF

'it's a new day, add day number to traktime file
	  OPEN trakt$ FOR RANDOM AS 11 LEN = LEN(traktime)
	  GET 11, day%, traktime
	  traktime.day = VAL(MID$(DATE$, 4, 2))
	  PUT 11, day%, traktime
	  CLOSE 11

' its a new day! copy today's bulletin to yesterday's "who called" bulletin
  IF (tbullb$ <> "") AND (ybullb$ <> "") THEN
	CALL copyfile(tbullb$ + CHR$(0), ybullb$ + CHR$(0), errcode%)
	Ybulltotal ybullb$
  END IF
  IF (tbullc$ <> "") AND (ybullc$ <> "") THEN
	CALL copyfile(tbullc$ + CHR$(0), ybullc$ + CHR$(0), errcode%)
	Ybulltotal ybullc$
  END IF

' recreate today's bulletin, only if both bbs and cbs versions are nonempty
 IF tbullb$ <> "" AND tbullc$ <> "" THEN
	OPEN tbullb$ FOR OUTPUT AS 6
	OPEN tbullc$ FOR OUTPUT AS 7
	opening$ = "User Activity Detail for " + current$ + " - Tracker! " + ver$
	PRINT #6, ""
	PRINT #6, SPACE$(39 - (LEN(opening$) / 2)) + opening$
	PRINT #6, STRING$(79, 45)
	PRINT #6, SPACE$(2) + "Name" + SPACE$(17) + "From" + SPACE$(22) + "Logon @" + SPACE$(4) + "Logoff @" + SPACE$(3) + "Used"
	PRINT #6, STRING$(79, 45)
	PRINT #6, ""
	PRINT #7, CHR$(27) + "[2J"    'clear screen
	PRINT #7, hue$(info) + SPACE$(39 - (LEN(opening$) / 2)) + opening$ + CHR$(27) + "[0m"
	PRINT #7, hue$(border) + STRING$(79, 196) + CHR$(27) + "[0m"
	PRINT #7, hue$(info) + SPACE$(2) + "Name" + SPACE$(17) + "From" + SPACE$(22) + "Logon @" + SPACE$(4) + "Logoff @" + SPACE$(3) + "Used" + CHR$(27) + "[0m"
	PRINT #7, hue$(border) + STRING$(79, 196) + CHR$(27) + "[0m"
	PRINT #7, ""
	CLOSE 6, 7
 END IF 'tbullb$<>"" and ybullb$<>""

'new day! if Sunday, create a report and clear data
	IF day% = 1 THEN
	  WeeklyStat
	END IF
  END IF

  COLOR 15, bground
  LOCATE 24, 66
  PRINT SPACE$(6);  'overwrite (WAIT)
  COLOR info, 0

  IF event = 1 THEN
	VIEW PRINT 5 TO 23
   ELSE
	VIEW PRINT 4 TO 23
  END IF

'main loop of reading TRAKSCRN.BBS / TRAKSCRN.CBS
  trakscrn$ = "TRAKSCRN."'temp variable with text file name
  IF ansi$ = "ANSI" THEN
	f$ = tpath$ + trakscrn$ + "CBS"
   ELSE
	f$ = tpath$ + trakscrn$ + "BBS"
  END IF
  trakscrn$ = ""

' check for its existence
  e% = 0
  CALL exist(f$ + CHR$(0), e%)
  IF e% THEN   ' just skip it...  maybe they don't want a screen
	aa = FREEFILE
	IF fileshare THEN
	  OPEN f$ FOR INPUT AS aa
	 ELSE
	  OPEN f$ FOR INPUT AS aa
	END IF
	DO WHILE NOT EOF(aa)
		LINE INPUT #aa, ln$

		IF INSTR(UCASE$(ln$), "@CHECKFORMAIL") THEN
		  GOSUB CheckForMail
		 ELSEIF INSTR(UCASE$(ln$), "@CHECKFORRATIO") THEN
		  GOSUB CheckForRatio
		 ELSE
		  Variablecode ln$
		  Send ln$
		END IF
	  LOOP
	  CLOSE
	END IF

	IF baud$ <> "LOCAL" THEN    ' Close the comport!
	  CloseComm
	  UEVENT OFF
	END IF

'update TRACKER.INF
	OPEN trakinf$ FOR OUTPUT AS 1
	PRINT #1, total$
	IF user.level <> "0" THEN
	  PRINT #1, orgwhole$
	  PRINT #1, LEFT$(user.location, INSTR(user.location, CHR$(0)) - 1)
	 ELSE
	  PRINT #1, laston$
	  PRINT #1, city$
	END IF

	PRINT #1, DATE$

	IF today$ = DATE$ THEN
	  PRINT #1, ctoday$
	 ELSE
	  PRINT #1, "0"
	END IF

	PRINT #1, LTRIM$(STR$(A))' record number
	PRINT #1, TIME$ ' time for ending
	PRINT #1, user.level
	CLOSE

	PRINT
	ScrPause
	VIEW PRINT 1 TO 25
	CALL clrkbd
	LOCATE 24, 49
	CLOSE

	IF register = false THEN CALL delay(4)
	CALL DMPrint(hue$(7))

'write a confirmed logon file
	ff = FREEFILE
	OPEN tpath$ + "TLOGON.OK" FOR OUTPUT AS ff
	CLOSE ff
	END     'MAIN CODE


Lab20000:
'error handling
	COLOR 12
	BEEP
	PRINT "Error " + STR$(ERR) + "at line " + STR$(ERL)
	OPEN tpath$ + "TRACKER.ERR" FOR APPEND AS 50
	PRINT #50, ver$; ", "; TIME$; SPACE$(1); DATE$; ": error " + STR$(ERR) + "at line " + STR$(ERL)
	CLOSE
	END

'uevent triggered - carrier loss
	BEEP
	COLOR 15, bground
	LOCATE 25, 1
	PRINT " (Carrier Loss!  Exiting safely...) "
	GOTO Lab30010
	RETURN

Lab30010:
	IF UCASE$(baud$) <> "LOCAL" THEN
	  CloseComm
	  END
	END IF



CHECKFOREVENT:
	IF event = 1 THEN
	  Send hue$(12) + SPACE$(2) + "A necessary system event has reduced your time online for this call."
	END IF
	RETURN 'CheckForEvent


CheckForRatio:
	IF user.dnloadfiles = 0 OR user.dnloadk = 0 THEN RETURN

' check for access levels to bypass
	IF INSTR(exemptlvl$, user.level) <> 0 THEN
	  saveline = CSRLIN
	  VIEW PRINT 1 TO 25
	  LOCATE 24, 66
	  COLOR 15, bground
	  PRINT "(EXMT)";
	  COLOR 7, 0
	  VIEW PRINT 1 TO 23
	  LOCATE saveline
	  RETURN
	END IF

	IF user.uploadfiles = 0 THEN user.uploadfiles = 1
	IF user.uploadk = 0 THEN user.uploadk = 1
	userratiof = user.dnloadfiles / user.uploadfiles
	userratiok = user.dnloadk / user.uploadk
	IF userratiok > ratiok THEN bal = 1
	IF userratiof > ratiof THEN bal = 1


	RETURN 'CheckForRatio

CheckForMail:
	CALL exist(trakdb$ + CHR$(0), trakdbhere%)
	IF trakdbhere% THEN

'inform user of wait
	  ln$ = hue$(bright) + "*" + SPACE$(1) + "Checking for your mail; please wait..."
	  Transmit SPACE$(3) + ln$
	  CALL DMPrint(SPACE$(3) + ln$)

	  ff = FREEFILE
	  OPEN trakdir$ FOR RANDOM AS ff LEN = LEN(dir)' load msgbase descriptions
	  FOR R = 1 TO LOF(ff) / LEN(dir)
		GET ff, R, dir
		desc$(R) = MID$(dir.desc, 2, ASC(LEFT$(dir.desc, 1)))
	  NEXT R
	  CLOSE ff

	  messageswaiting = false
	  ff = FREEFILE
	  OPEN traknames$ FOR INPUT AS ff
	  DO WHILE NOT EOF(ff)
		  LINE INPUT #ff, nameline$
		  IF nameline$ = whole$ THEN
			messageswaiting = true
			EXIT DO
			END IF
		  LOOP
		  CLOSE (ff)

		  ln$ = STRING$(43, 8) + clreol$'erase wait line
		  Transmit ln$
		  CALL DMPrint(ln$)

		  IF messageswaiting = true AND ncalls = 1 THEN
			ln$ = hue$(text) + "You have mail waiting for you, " + hue$(bright) + "@F@" + hue$(text) + ", in these areas:"
			Variablecode ln$
			Send SPACE$(2) + ln$
			ff = FREEFILE
			OPEN trakdb$ FOR RANDOM AS ff LEN = LEN(db)
			FOR R = 1 TO LOF(ff) / LEN(db)
			  GET ff, R, db
			  IF db.user = A AND db.mailpresent = CHR$(1) THEN
				Send SPACE$(3) + desc$(db.area)
			  END IF
			  db.mailpresent = CHR$(0)'this is to avoid us telling user again if they call
			  PUT ff, R, db'before a TSCAN is done again.
			NEXT R
			CLOSE ff
		   ELSEIF ncalls <> 1 THEN
			ln$ = hue$(text) + "The status of your mail has not been updated since your last call."
			Variablecode ln$
			Send SPACE$(2) + ln$
		   ELSEIF messageswaiting = false AND ncalls = 1 THEN
			ln$ = hue$(text) + "You have no mail waiting for you, " + hue$(bright) + "@F@" + hue$(text) + "."
			Variablecode ln$
			Send SPACE$(2) + ln$
		  END IF

'remove name from TSCAN.NAM file
		  ff = FREEFILE
		  OPEN traknames$ FOR INPUT AS ff
		  gg = FREEFILE
		  OPEN traknamesnew$ FOR OUTPUT AS gg
		  DO WHILE NOT EOF(ff)
			  LINE INPUT #ff, nameline$
			  IF nameline$ <> whole$ THEN PRINT #gg, nameline$
			LOOP
			CLOSE (ff)
			CLOSE (gg)
			CALL copyfile(traknamesnew$ + CHR$(0), traknames$ + CHR$(0), errcode%)
			KILL traknamesnew$


		  END IF 'end if for the main MAIL if statement
		  RETURN 'CheckForMail


Registration:
		  'recreate bbs name to be the old style (TRC  #1) from the 3-part
		  'information we now have in 2.01
		  registrationline$ = bbs$ + SPACE$(2) + "#" + LTRIM$(RTRIM$(STR$(serial)))

		  regv1 = 0
		  REG registrationline$, regv1
		  regv2 = 0
		  REG2 registrationline$, regv2
		  crc$ = HEX$(regv1) + "-" + HEX$(regv2)

		  IF usercrc$ = crc$ THEN register = true
		  IF register = true THEN
			LOCATE 25, 68
			COLOR 15, bground
			PRINT SPACE$(1) + registeredstr$ + SPACE$(1);
		   ELSE
			LOCATE 25, 66
			COLOR 31, 4
			PRINT SPACE$(1) + unregisteredstr$ + SPACE$(1);
		  END IF

		  COLOR 15, bground

		  RETURN 'registration

REM $STATIC
SUB Acceptuser (acceptfile$, Baudrate$, Username$, deny%)
  CALL exist(acceptfile$ + CHR$(0), found%)
  IF NOT found% THEN
	deny% = 0
	EXIT SUB
  END IF
  ff = FREEFILE
  IF fileshare THEN
	OPEN acceptfile$ FOR INPUT ACCESS READ SHARED AS ff
   ELSE
	OPEN acceptfile$ FOR INPUT AS ff
  END IF
  WHILE NOT EOF(ff)
	LINE INPUT #ff, ln$
	IF LTRIM$(UCASE$(ln$)) = "ACCEPT " + Baudrate$ THEN
	  DO
		LINE INPUT #ff, name$
		IF LTRIM$(UCASE$(Username$)) = LTRIM$(UCASE$(name$)) THEN
		  deny% = 0
		  CLOSE ff
		  EXIT SUB
		END IF
	  LOOP UNTIL UCASE$(name$) = "END"
	  deny% = -1
	  CLOSE ff
	  EXIT SUB
	END IF
  WEND
  CLOSE ff
END SUB

SUB Box (TRow%, BRow%, LCol%, RCol%, f%, B%) STATIC

  COLOR f%, B%
  wide% = RCol% - LCol%
  Hgt% = BRow% - TRow%

  LOCATE TRow%, LCol%
  PRINT "" + STRING$(wide% - 1, 196) + ""
  FOR d = 1 TO Hgt% - 1
	LOCATE TRow% + d, LCol%
	PRINT "" + SPACE$(wide% - 1) + ""
  NEXT d
  LOCATE BRow%, LCol%
  PRINT "" + STRING$(wide% - 1, 196) + "";

END SUB

SUB CTR (st$)
  stlen = LEN(st$)
  PRINT SPACE$(38 - (stlen / 2)) + st$
END SUB

SUB DebugInfoFile (timeonlinethiscall%, timeonlinebefore%, timeonlineafter%, todaynum%, who%)
' who%:  -1=sysop, 0=user



pp = FREEFILE

OPEN tpath$ + "TRAKTIME.BUG" FOR APPEND AS #pp
PRINT #pp, DATE$ + SPACE$(1) + TIME$ + SPACE$(2) + "Day%="; LTRIM$(RTRIM$(STR$(day%)));
IF who% = -1 THEN PRINT #pp, " SYSP";
IF who% = 0 THEN PRINT #pp, " USER";
PRINT #pp, " prev online "; LTRIM$(RTRIM$(STR$(timeonlinebefore%)));
PRINT #pp, ", this call "; LTRIM$(RTRIM$(STR$(timeonlinethiscall%)));
PRINT #pp, ", total "; LTRIM$(RTRIM$(STR$(timeonlineafter%)))

CLOSE pp

END SUB

SUB DivLine (C%)    ' C% is color to return with
  COLOR 8
  PRINT STRING$(79, 196)
  COLOR C%
END SUB

SUB DrawScreen

'draw initial screen
  CLS
'  CALL UNCRUNCH(TRSCREEN&, 0)
  FOR i = 1 TO 1000: NEXT i
 
  COLOR bground

  LOCATE 24, 1
  PRINT STRING$(79, 219);
  LOCATE 25, 1
  PRINT STRING$(79, 219);
  LOCATE 25, 50
  COLOR 15, bground
  PRINT SPACE$(1) + "Tracker " + ver$ + SPACE$(1);

  COLOR info, 0

END SUB

SUB DropAtBaud (dropbaud$) STATIC

  IF showbaud$ = dropbaud$ THEN
	CALL exist(acceptfile$ + CHR$(0), gotit%)
	IF gotit% THEN
	  Acceptuser acceptfile$, showbaud$, whole$, deny%
	  IF deny% = -1 THEN
		GOTO Lab7300
	   ELSE
		EXIT SUB
	  END IF
	END IF
Lab7300:
	ln$ = CRLF$ + hue$(12) + SPACE$(3) + "Connections at " + dropbaud$ + " baud are not currently being accepted." + CRLF$ + SPACE$(3) + "Click!" + CRLF$ + CRLF$
	Transmit ln$
	COLOR 12
	LOCATE 7, 1
	PRINT SPACE$(6) + "Connections at " + dropbaud$ + " baud are not currently being accepted."
	PRINT SPACE$(6) + "Click!"
	DTRcontrol 0
	CloseComm
	END
  END IF

END SUB

SUB EnterMSG (GTPath$, subj$, day%, msgfile$)
'parse GT.CNF to find sysop base
  IF fileshare THEN
	OPEN GTPath$ + "GT.CNF" FOR INPUT ACCESS READ SHARED AS 8
   ELSE
	OPEN GTPath$ + "GT.CNF" FOR INPUT AS 8
  END IF
  DO WHILE NOT EOF(8)
	  LINE INPUT #8, ln$
	  IF LEFT$(ln$, 3) = "SM=" THEN
		sysmsg$ = RIGHT$(ln$, LEN(ln$) - 3)
		EXIT DO
		END IF
	  LOOP
	  IF RIGHT$(sysmsg$, 1) <> "\" THEN sysmsg$ = sysmsg$ + "\"
	  CLOSE 8
'open SYSOP.BBS to find sysop name
	  IF fileshare THEN
		OPEN GTPath$ + "SYSOP.BBS" FOR INPUT ACCESS READ SHARED AS 8
	   ELSE
		OPEN GTPath$ + "SYSOP.BBS" FOR INPUT AS 8
	  END IF
	  FOR x = 1 TO 3
		LINE INPUT #8, ln$
	  NEXT x
	  sysopname$ = ln$
	  CLOSE 8
'open message in base
	  OPEN sysmsg$ + "MESSAGE.CTL" FOR RANDOM AS 8 LEN = LEN(msg)
	  lastmsg = LOF(8) / LEN(msg)
	  GET 8, lastmsg, msg
	  msg.deleted = CHR$(0)
	  msg.msgnumber = msg.msgnumber + 1
	  msg.sender = "Tracker " + ver$ + CHR$(0)
	  msg.whoto = LEFT$(sysopname$, 30) + CHR$(0)
	  msg.subj = subj$ + CHR$(0)
	  mdate$ = DATE$
	  mdate$ = LEFT$(mdate$, 6) + RIGHT$(mdate$, 2)
	  IF LEFT$(mdate$, 1) = "0" THEN mdate$ = RIGHT$(mdate$, LEN(mdate$) - 1)
	  msg.msgdate = mdate$ + CHR$(0)
	  mtime$ = LEFT$(TIME$, 5)
	  IF LEFT$(mtime$, 1) = "0" THEN mtime$ = SPACE$(1) + RIGHT$(mtime$, 4)
	  msg.msgtime = mtime$ + CHR$(0)
	  msg.weekday = CHR$(day%)
	  msg.destnet = 0
	  msg.destnode = 0
	  msg.priv = CHR$(1)
	  msg.recv = CHR$(0)
	  PUT 8, lastmsg + 1, msg
	  CLOSE 8
	  newmsg = msg.msgnumber
	  IF gtver = 15 THEN
		IF newmsg > 0 AND newmsg < 10 THEN msgfile$ = sysmsg$ + "GTMSGS\0000" + LTRIM$(STR$(newmsg)) + ".MSG"
		IF newmsg >= 10 AND newmsg < 100 THEN msgfile$ = sysmsg$ + "GTMSGS\000" + LTRIM$(STR$(newmsg)) + ".MSG"
		IF newmsg >= 100 AND newmsg < 1000 THEN msgfile$ = sysmsg$ + "GTMSGS\00" + LTRIM$(STR$(newmsg)) + ".MSG"
		IF newmsg >= 1000 AND newmsg < 10000 THEN msgfile$ = sysmsg$ + "GTMSGS\0" + LTRIM$(STR$(newmsg)) + ".MSG"
		IF newmsg > 10000 THEN msgfile$ = sysmsg$ + "GTMSGS\" + LTRIM$(STR$(newmsg)) + ".MSG"
	   ELSE ' assume GT 16-18 compatible
		msgfile$ = sysmsg$ + "GTMSGS\" + GetMESfile$(newmsg)
	  END IF
	END SUB

SUB FixTime (timec$, newtime$)
'fix time
  CALL times2n(hour%, min%, sec%, timec$)
  IF hour% > 12 THEN
	hour% = hour% - 12
	pm = -1
  END IF
  IF hour% = 12 THEN pm = -1
  IF hour% >= 10 OR hour% = 0 THEN
	spacing$ = SPACE$(9)
   ELSE
	spacing$ = SPACE$(10)
  END IF
  timec$ = SPACE$(8)
  CALL timen2s(hour%, min%, sec%, timec$)
  timec$ = LTRIM$(RTRIM$(timec$))
  IF LEFT$(timec$, 2) = "00" THEN timec$ = "12" + MID$(TIME$, 3, 3)
  IF LEFT$(timec$, 1) = "0" THEN
	timec$ = MID$(timec$, 2, 4) + " "
   ELSE
	timec$ = LEFT$(timec$, 5) + " "
  END IF
  IF pm = -1 THEN
	timec$ = timec$ + "pm"
   ELSE
	timec$ = timec$ + "am"
  END IF
  newtime$ = timec$
END SUB

FUNCTION GetMESfile$ (msnum)

  roundnum = INT((msnum - 1) / 10) + 1'returns closest XXXXX.MES file

  IF msnum > roundnum THEN
	IF msnum < 91 THEN GetMESfile$ = "0000" + LTRIM$(STR$(roundnum)) + ".MES"
	IF msnum >= 91 AND msnum < 991 THEN GetMESfile$ = "000" + LTRIM$(STR$(roundnum)) + ".MES"
	IF msnum >= 991 AND msnum < 9991 THEN GetMESfile$ = "00" + LTRIM$(STR$(roundnum)) + ".MES"
	IF msnum >= 9991 THEN GetMESfile$ = "0" + LTRIM$(STR$(roundnum)) + ".MES"
  END IF

END FUNCTION

FUNCTION GetSOMnum (msnum)

  GetSOMnum = (msnum - 1) MOD 10

END FUNCTION

SUB Init

  VIEW PRINT 1 TO 25

  DrawScreen
  COLOR 15, 1
  LOCATE 25, 66
  PRINT "Initialization";

  OPEN userctl$ FOR RANDOM AS 1 LEN = 176
  ons = 0
  recs = LOF(1) / LEN(user)

  ParseUser
  CALL Box(5, 14, 9, 67, INT(border), 0)
  IF INSTR(COMMAND$, "OVERRIDE") <> 0 THEN
	LOCATE 18
	COLOR bright, 0
	CTR "OVERRIDE specified: All level 0 users' calls will be added to total."
  END IF

  COLOR text
  LOCATE 7, 12
  PRINT "Initializing, please wait..."

  FOR A = 2 TO recs
	GET 1, A, user
	LOCATE 8, 21
	IF LEFT$(user.whole, LEN(whole$)) = whole$ THEN locale$ = LEFT$(user.location, INSTR(user.location, CHR$(0)) - 1)
	ons = user.timeson
	LOCATE 9, 21
	IF user.deleted = CHR$(1) OR user.banned = CHR$(1) THEN
	  PRINT "Skip";
	  FOR sd = 1 TO 400               'small delay
	  NEXT sd
	  LOCATE 9, 21
	  PRINT SPACE$(12);
	  GOTO Lab2530
	 ELSE
	  PRINT STR$(A - 1) + ": " + user.whole
	END IF

	IF INSTR(COMMAND$, "OVERRIDE") <> 0 THEN
	  IF LEFT$(user.level, 1) = "0" THEN user.level = "1"
	END IF

	IF LEFT$(user.level, 1) <> "0" THEN
	  total = total + ons
	END IF
Lab2530:
	LOCATE 10, 21
	PRINT total
  NEXT A
  CLOSE 1

  COLOR info
  LOCATE 12, 12
  PRINT "Writing " + UCASE$(trakinf$) + " caller information file..."

  OPEN trakinf$ FOR OUTPUT AS 2
  PRINT #2, LTRIM$(STR$(total))
  PRINT #2, "The Custodian"
  PRINT #2, "Tracker"
  PRINT #2, DATE$
  PRINT #2, "1"
  PRINT #2, STR$(A)
  PRINT #2, TIME$
  PRINT #2, "A"
  CLOSE 2
  LOCATE 24, 1

END SUB

SUB Logoff STATIC

  VIEW PRINT 1 TO 25

  DrawScreen

  COLOR 15, bground
  LOCATE 25, 66
  PRINT "Logoff Scan";
  COLOR 7, 0
  LOCATE 1, 1

'if TLOGON.OK doesn't exist, then incomplete logon therefore exit
  CALL exist(tpath$ + "TLOGON.OK" + CHR$(0), here%)
  IF NOT here% THEN
	PRINT "- Tracker not executed upon logon.  Logon was probably incomplete."
	END
   ELSE
	KILL tpath$ + "TLOGON.OK"
  END IF

  ParseUser

  VIEW PRINT 1 TO 25
' find mins on and prepare to write bulletin
  ZF = FREEFILE
  OPEN trakinf$ FOR INPUT AS ZF
  LINE INPUT #ZF, totalcall$'skip unimportant stuff
  LINE INPUT #ZF, laston$'skip unimportant stuff
  LINE INPUT #ZF, city$'skip unimportant stuff
  LINE INPUT #ZF, today$'skip unimportant stuff
  LINE INPUT #ZF, calltoday$'skip unimportant stuff
  LINE INPUT #ZF, userrec$'skip unimportant stuff
  LINE INPUT #ZF, logtime$
  CLOSE ZF

' this breaks down the time
  CALL times2n(hour%, min%, sec%, logtime$)
  tim$ = TIME$
  CALL times2n(hour2%, min2%, sec2%, tim$)
' fix 00 to 24 and subtract times
  IF hour% = 23 AND hour2% = 0 THEN hour2% = 24
  Fhour% = hour2% - hour%
  Fmin% = min2% - min%
  Ftime% = (Fhour% * 60) + Fmin%      'final time
  PRINT "- ";
  COLOR bright
  PRINT whole$; SPACE$(3); city$
  COLOR text
  PRINT "- Time online during this call: ";
  COLOR bright
  PRINT LTRIM$(STR$(Ftime%));
  COLOR text
  PRINT " minutes"

  IF level$ = "0" THEN
	COLOR text
	PRINT
	PRINT "- SYSOP was online, skipping bulletin entry"
'update SYSOP time on
	OPEN trakt$ FOR RANDOM AS 12 LEN = LEN(traktime)
	GET 12, day%, traktime
	PRINT "DEBUG INFO"
	PRINT "traktime.stime = "; traktime.stime; " plus "; Ftime%; " online = ";
	origtime% = traktime.stime
	traktime.stime = traktime.stime + Ftime%
	PRINT traktime.stime; " total for day%="; day%
	CALL DebugInfoFile(Ftime%, origtime%, traktime.stime, day%, -1)
	PUT 12, day%, traktime
	CLOSE
	LOCATE 24, 1
	END
  END IF

'if it gets this far, then USER is on
  OPEN trakt$ FOR RANDOM AS 12 LEN = LEN(traktime)
  GET 12, day%, traktime
  PRINT "DEBUG INFO"
  IF override = false THEN
	PRINT "traktime.utime = "; traktime.utime; " plus "; Ftime%; " online = ";
	origtime% = traktime.utime
	traktime.utime = traktime.utime + Ftime%
	PRINT traktime.utime; " total for day%="; day%
	CALL DebugInfoFile(Ftime%, origtime%, traktime.utime, day%, 0)
   ELSE
	PRINT "traktime.stime = "; traktime.stime; " plus "; Ftime%; " online = "
	origtime% = traktime.stime
	traktime.stime = traktime.stime + Ftime%
	PRINT traktime.stime; " total for day%="; day%
	CALL DebugInfoFile(Ftime%, origtime%, traktime.stime, day%, -1)
  END IF
  PUT 12, day%, traktime
  CLOSE 12

' prepare bulletin
IF tbullb$ <> "" AND tbullc$ <> "" THEN
  IF today$ = DATE$ THEN
	OPEN tbullb$ FOR APPEND AS 6
	OPEN tbullc$ FOR APPEND AS 7
  END IF

' append body of bulletin
  COLOR text
  PRINT "- Adding user to caller log bulletin"
  FixTime logtime$, timeon$
  FixTime TIME$, timeoff$

' fix spacing in time for bulletin
  IF MID$(timeon$, 2, 1) = ":" THEN timeon$ = SPACE$(1) + timeon$
  IF MID$(timeoff$, 2, 1) = ":" THEN timeoff$ = SPACE$(1) + timeoff$
  PRINT #6, SPACE$(2) + LEFT$(laston$, 20); TAB(24); LEFT$(city$, 25); TAB(50); timeon$; TAB(61); timeoff$; TAB(73); LTRIM$(STR$(Ftime%))
  PRINT #7, CHR$(27) + "[1;37m" + SPACE$(2) + LEFT$(laston$, 20); TAB(30); LEFT$(city$, 25); TAB(56); timeon$; TAB(67); timeoff$; TAB(79); LTRIM$(STR$(Ftime%)); CHR$(27) + "[0m"
  CLOSE
  COLOR text
END IF

  LOCATE 24, 1
  END

END SUB

SUB NumberOfUsers STATIC

  ff = FREEFILE
  OPEN userctl$ FOR RANDOM AS ff LEN = LEN(user)
  NumberUsers = LOF(ff) / LEN(user)
  CLOSE ff

END SUB

SUB ParseUser STATIC

' parse GTUSER.BBS
  OPEN gtuser$ FOR INPUT AS 9
  LINE INPUT #9, gtus$
  CLOSE 9

  words% = QWORDS%(gtus$)
  g$ = gtus$
  length = LEN(g$)
  max = (length / 2) + 1
  true = -1
  false = 0
  i = 1
  num = 0
  inword = true
  WHILE i <= length
	ch$ = MID$(g$, i, 1)
	IF ch$ <> " " THEN
	  IF NOT inword THEN inword = true
	  Param$(num) = Param$(num) + ch$
	 ELSEIF inword THEN
	  num = num + 1
	  inword = false
	END IF
	i = i + 1
  WEND

'check for 1 word names
  IF words% = 9 OR INSTR(gtus$, ";") THEN     ' should be 10 for 2 word names!
	Param$(2) = ""
	oneword = 1
  END IF

  IF oneword <> 1 THEN
	whole$ = Param$(1) + " " + Param$(2)
	first$ = Param$(1)
	last$ = Param$(2)
   ELSE
	whole$ = Param$(1)
	first$ = Param$(1)
	last$ = ""
  END IF

  level$ = Param$(0)
  IF INSTR(Param$(words% - 6), ",") THEN
	baud$ = LTRIM$(STR$(VAL(LEFT$(Param$(words% - 6), INSTR(Param$(words% - 6), ",") - 1))))
	dce$ = LTRIM$(STR$(VAL(RIGHT$(Param$(words% - 6), LEN(Param$(words% - 6)) - INSTR(Param$(words% - 6), ",")))))
   ELSE
	baud$ = LTRIM$(STR$(VAL(Param$(words% - 6))))
	dce$ = baud$
  END IF

  IF Param$(words% - 6) = "LOCAL" THEN baud$ = "LOCAL"
  ansi$ = Param$(words% - 5)
  logontime$ = LTRIM$(RIGHT$(gtus$, 5))
  A$ = Param$(words% - 3)    'time left
  B$ = Param$(words% - 2)    'time till event
  UserTime logontime$

END SUB

SUB REG (BBSNAME$, Regvalue)

  adding = 0
  bbslen = LEN(BBSNAME$)
  IF bbslen < 6 THEN
	Regvalue = 0
	Registered$ = ""
  END IF
  FOR A = 1 TO bbslen
	ch$ = MID$(BBSNAME$, A, 1)
	adding = adding + ASC(ch$)
  NEXT A

  ch$ = MID$(BBSNAME$, 3, 1)
  adding = adding + (INT(ASC(ch$) * 9.14))
  ch$ = MID$(BBSNAME$, 2, 1)
  adding = adding + (INT(ASC(ch$) * 3.14159))
  ch$ = MID$(BBSNAME$, 5, 1)
  adding = adding + (INT(ASC(ch$) * 18.2 / 1.15))
  ch$ = MID$(BBSNAME$, 1, 1)
  adding = INT(adding + (INT(ASC(ch$) * 7.2)))
  adding = INT(adding * 5.35 / 1.0775)
  Regvalue = adding

END SUB

SUB REG2 (BBSNAME$, Regvalue)

  adding = 0
  bbslen = LEN(BBSNAME$)
  IF bbslen < 6 THEN
	Regvalue = 0
	Registered$ = ""
  END IF
  FOR A = 1 TO bbslen
	ch$ = MID$(BBSNAME$, A, 1)
	adding = adding + ASC(ch$)
  NEXT A

  ch$ = MID$(BBSNAME$, 1, 1)
  adding = adding + (INT(ASC(ch$) * 3.21))
  ch$ = MID$(BBSNAME$, 4, 1)
  adding = adding + (INT(ASC(ch$) * 6.9))
  ch$ = MID$(BBSNAME$, 5, 1)
  adding = adding + (INT(ASC(ch$) * 9.2 / .87))
  ch$ = MID$(BBSNAME$, 2, 1)
  adding = INT(adding + (INT(ASC(ch$) * 3.2)))
  adding = INT(adding * 8.35 / 1.9875)
  Regvalue = adding

END SUB

SUB ScrPause STATIC

'stat$ will be either "remote" or "local"

  IF baud$ <> "LOCAL" OR null = true THEN EXIT SUB
  COLOR text
  PRINT SPACE$(4) + "Press ";
  COLOR bright
  PRINT "any key";
  COLOR text
  PRINT " to continue...";
  DO UNTIL INKEY$ <> ""
  LOOP
  LOCATE CSRLIN, 5
  PRINT SPACE$(29);
  LOCATE CSRLIN, 1

END SUB

SUB Send (ln$) 'local space and remote space

  Transmit SPACE$(1) + ln$ + CRLF$

  CALL DMPrint(SPACE$(1) + ln$)
  PRINT
  ln$ = ""
END SUB

SUB stripit (ln$) STATIC

  whole3$ = ln$
  CALL extract(whole3$, CHR$(0), 1, Start%, slen2%)
  whole4$ = MID$(whole3$, Start%, slen2%)
  CALL Striprange(whole4$, 0, 47, mlen2%)
  whole5$ = LEFT$(whole4$, mlen2%)
  CALL Striprange(whole5$, 58, 63, mlen3%)
  whole6$ = LEFT$(whole5$, mlen3%)
  CALL Striprange(whole6$, 91, 96, mlen4%)
  whole7$ = LEFT$(whole6$, mlen4%)
  CALL Striprange(whole7$, 123, 255, mlen5%)
  whole8$ = LEFT$(whole7$, mlen5%)

  ln$ = whole8$
END SUB

SUB UserTime (logontime$) STATIC

'TIME ANALYSIS - "a" is always smallest time left

  tillevent = VAL(B$)
  normalmin = VAL(A$)

  currenthour = VAL(MID$(TIME$, 1, 2))
  currentmin = VAL(MID$(TIME$, 4, 2))

  IF LEN(logontime$) = 4 THEN
	logmin = VAL(MID$(logontime$, 3, 2))
	loghour = VAL(LEFT$(logontime$, 1))
  END IF

  IF LEN(logontime$) = 5 THEN
	logmin = VAL(MID$(logontime$, 4, 2))
	loghour = VAL(MID$(logontime$, 1, 2))
  END IF

  IF loghour = 24 THEN loghour = 0
  current = (currenthour * 60) + currentmin
  logon = (loghour * 60) + logmin

  timesofar = INT(current - logon)
  IF timesofar < 0 THEN timesofar = 0

  IF tillevent <= normalmin THEN
	A = tillevent
	A = A - 6
	event = 1
  END IF
  IF tillevent > normalmin THEN
	A = normalmin
	event = 0
  END IF
  timeleft$ = LTRIM$(STR$(A - timesofar))

END SUB

SUB WeeklyStat STATIC
  EnterMSG GTPath$, "Weekly Statistical Information", day%, msgfile$
  OPEN trakt$ FOR RANDOM AS 9 LEN = LEN(traktime)
  FOR J = 1 TO 7
	GET 9, J, traktime
	uc(J) = traktime.ucall
	sc(J) = traktime.scall
	ut(J) = traktime.utime
	st(J) = traktime.stime
	dy(J) = traktime.day
  NEXT J
  CLOSE 9
'calculate stats
  FOR J = 1 TO 7
	totalucalls = totalucalls + uc(J)
	totalscalls = totalscalls + sc(J)
	totalutime = totalutime + ut(J)
	totalstime = totalstime + st(J)
	daypercent(J) = ((ut(J) + st(J)) / 1440) * 100
  NEXT J
  totaltime = totalutime + totalstime
  weekpercent = (totaltime / (1440 * 7)) * 100
  avgcallmin = totalutime / totalucalls

  IF gtver = 15 THEN
	OPEN msgfile$ FOR OUTPUT AS 8
   ELSE 'assume 16-18 compatible
	OPEN msgfile$ FOR APPEND AS 8
	PRINT #8, CHR$(24) + "SOM" + LTRIM$(STR$(GetSOMnum(newmsg)))
  END IF

  ln$ = "TRACKER Statistical Analysis of BBS Performance over the past week"
  PRINT #8, SPACE$(39 - (LEN(ln$) / 2)) + ln$
  PRINT #8, STRING$(78, 45)
  PRINT #8, "         Users     Sysop       Users    Sysop"
  PRINT #8, STRING$(78, 45)
  PRINT #8, ""
  PRINT #8, " Sun " + LTRIM$(STR$(dy(1))); TAB(12); LTRIM$(STR$(uc(1))); " calls"; TAB(22); LTRIM$(STR$(sc(1))); " calls"; TAB(34); LTRIM$(STR$(ut(1))); " min"; TAB(43); LTRIM$(STR$(st(1))); " min"
  PRINT #8, " Mon " + LTRIM$(STR$(dy(2))); TAB(12); LTRIM$(STR$(uc(2))); TAB(22); LTRIM$(STR$(sc(2))); TAB(34); LTRIM$(STR$(ut(2))); TAB(43); LTRIM$(STR$(st(2)))
  PRINT #8, " Tue " + LTRIM$(STR$(dy(3))); TAB(12); LTRIM$(STR$(uc(3))); TAB(22); LTRIM$(STR$(sc(3))); TAB(34); LTRIM$(STR$(ut(3))); TAB(43); LTRIM$(STR$(st(3)))
  PRINT #8, " Wed " + LTRIM$(STR$(dy(4))); TAB(12); LTRIM$(STR$(uc(4))); TAB(22); LTRIM$(STR$(sc(4))); TAB(34); LTRIM$(STR$(ut(4))); TAB(43); LTRIM$(STR$(st(4)))
  PRINT #8, " Thu " + LTRIM$(STR$(dy(5))); TAB(12); LTRIM$(STR$(uc(5))); TAB(22); LTRIM$(STR$(sc(5))); TAB(34); LTRIM$(STR$(ut(5))); TAB(43); LTRIM$(STR$(st(5)))
  PRINT #8, " Fri " + LTRIM$(STR$(dy(6))); TAB(12); LTRIM$(STR$(uc(6))); TAB(22); LTRIM$(STR$(sc(6))); TAB(34); LTRIM$(STR$(ut(6))); TAB(43); LTRIM$(STR$(st(6)))
  PRINT #8, " Sat " + LTRIM$(STR$(dy(7))); TAB(12); LTRIM$(STR$(uc(7))); TAB(22); LTRIM$(STR$(sc(7))); TAB(34); LTRIM$(STR$(ut(7))); TAB(43); LTRIM$(STR$(st(7)))
  PRINT #8, STRING$(78, 45)
  PRINT #8, " Totals"; TAB(12); LTRIM$(STR$(totalucalls)); " calls"; TAB(22); LTRIM$(STR$(totalscalls)); " calls"; TAB(34); LTRIM$(STR$(totalutime)); " min"; TAB(43); LTRIM$(STR$(totalstime)); " min"
  PRINT #8, STRING$(78, 45)
  PRINT #8, ""
  PRINT #8, " Board Loading Detail"
  PRINT #8, " --------------------"
  PRINT #8, " Sun " + LTRIM$(STR$(dy(1))); TAB(15); "- " + LTRIM$(STR$(ut(1) + st(1))) + " minutes used   (" + LTRIM$(STR$(daypercent(1))) + "% daily usage)"
  PRINT #8, " Mon " + LTRIM$(STR$(dy(2))); TAB(15); "- " + LTRIM$(STR$(ut(2) + st(2))) + " minutes used   (" + LTRIM$(STR$(daypercent(2))) + "% daily usage)"
  PRINT #8, " Tue " + LTRIM$(STR$(dy(3))); TAB(15); "- " + LTRIM$(STR$(ut(3) + st(3))) + " minutes used   (" + LTRIM$(STR$(daypercent(3))) + "% daily usage)"
  PRINT #8, " Wed " + LTRIM$(STR$(dy(4))); TAB(15); "- " + LTRIM$(STR$(ut(4) + st(4))) + " minutes used   (" + LTRIM$(STR$(daypercent(4))) + "% daily usage)"
  PRINT #8, " Thu " + LTRIM$(STR$(dy(5))); TAB(15); "- " + LTRIM$(STR$(ut(5) + st(5))) + " minutes used   (" + LTRIM$(STR$(daypercent(5))) + "% daily usage)"
  PRINT #8, " Fri " + LTRIM$(STR$(dy(6))); TAB(15); "- " + LTRIM$(STR$(ut(6) + st(6))) + " minutes used   (" + LTRIM$(STR$(daypercent(6))) + "% daily usage)"
  PRINT #8, " Sat " + LTRIM$(STR$(dy(7))); TAB(15); "- " + LTRIM$(STR$(ut(7) + st(7))) + " minutes used   (" + LTRIM$(STR$(daypercent(7))) + "% daily usage)"
  PRINT #8, STRING$(78, 45)
  PRINT #8, " BBS was active " + LTRIM$(STR$(INT(totaltime / 60))) + " hours " + LTRIM$(STR$(((totaltime / 60) - INT(totaltime / 60)) * 60)) + " minutes this week."
  PRINT #8, " This is an average board loading of " + LTRIM$(STR$(weekpercent)) + "% for the week."
  PRINT #8, " Each call lasted an average of "; LTRIM$(STR$(avgcallmin)); " minutes."
  PRINT #8, STRING$(78, 45)
  PRINT #8, "Tracker " + ver$ + verdate$
  CLOSE 8
'clear records and set up for the next week.
  OPEN trakt$ FOR RANDOM AS 8 LEN = LEN(traktime)
  FOR J = 1 TO 7
	traktime.ucall = 0
	traktime.scall = 0
	traktime.utime = 0
	traktime.stime = 0
	traktime.day = 0
	PUT 8, J, traktime
  NEXT J
  CLOSE 8
END SUB

SUB Ybulltotal (bull$) STATIC
  ct = 0
  filenum = FREEFILE
  CALL exist(bull$ + CHR$(0), isthere%)
  IF NOT isthere% THEN GOTO Lab5000
  OPEN bull$ FOR INPUT AS filenum
  FOR trash = 1 TO 6' header info
	LINE INPUT #filenum, z$
  NEXT trash
  WHILE NOT EOF(filenum)  'find # calls
	ct = ct + 1
	LINE INPUT #filenum, z$
	IF LEFT$(z$, 1) = CHR$(27) THEN ansicode = 1   ' if ansi EVER shows up, that is..
  WEND
  CLOSE filenum

  OPEN bull$ FOR APPEND AS filenum
  IF ansicode <> 1 THEN
	PRINT #filenum, STRING$(79, 45)
	PRINT #filenum, "  - Total Calls: " + LTRIM$(STR$(ct))
   ELSE
	PRINT #filenum, hue$(border) + STRING$(79, 196)
	PRINT #filenum, hue$(info) + "  - Total Calls: " + CHR$(27) + "[37m" + LTRIM$(STR$(ct)) + CHR$(27) + "[0m"
  END IF
  CLOSE filenum

Lab5000:
END SUB

